#include <cstdlib>
#include <iostream>
#include "prof.h"
#include <conio.h>
#include <string.h>

using namespace std;

    struct mp3
    {
       char * titolo;
       char * autore;
       int durata;
       char * url;
       
       mp3* succ;
    };

                 
void ins_testa(  mp3* &il, string titolo, string autore, 
                 int durata, string url)
{
   mp3* p2 = NULL;
   p2 = (mp3*) malloc( sizeof(mp3) );

   p2->titolo = allocaStringa(titolo);
   p2->autore = allocaStringa(autore);
   p2 ->  durata = durata;
   p2->url = allocaStringa(url);
 
   p2->succ = il;
   
   il = p2;
}


void stampaLista(mp3* il)
{
  while (il != NULL)
  {
     
     cout << il->titolo << endl;
     il = il->succ;      
  }     
}

void ins_coda(mp3 * &il, string titolo, string autore, 
                 int durata, string url)
{
    if (il==NULL)
      ins_testa(il, titolo, autore, durata, url);
    else
    {
      mp3 * tmp = il;
          
      while (tmp->succ != NULL)
        tmp = tmp -> succ;
      
      mp3 * nuovo = (mp3*) malloc( sizeof(mp3) );

      nuovo->titolo = allocaStringa(titolo);
      nuovo->autore = allocaStringa(autore);
      nuovo ->  durata = durata;
      nuovo->url = allocaStringa(url);
      nuovo->succ = NULL;
      
      tmp->succ = nuovo;
    }
        
}


void distruggiLista(mp3 * &il)
{
   mp3 * tmp = NULL;
   
   while (il !=NULL)
   {
      tmp = il->succ;
      
      //liberiamo la memoria occupata
      //dalle stringhe puntate dai fields dell'mp3
      free(il->titolo);
      free(il->autore);
      free(il->url);
      
      free(il);
      il = tmp;
   }     
}

mp3 * cerca(mp3* il, string autore)
{
 
   while (il !=NULL && strcmp(il->autore, autore.c_str()) )
          il = il -> succ; 
     
   return il;
}


int main(int argc, char *argv[])
{

   mp3 *il = NULL;
   
   string num="";
   
   //creazione con inserimento in testa
   for (int i=0; i<5; i++)
   {
     num = intToString(i);
     ins_testa(il, "titolo"+num, "autore"+num, 
                   i, "url"+num);
   } 
    
   stampaLista(il);
   
   distruggiLista(il);
   
   cout << "Dopo distruzione: \n";
   stampaLista(il);
   
  //creazione con inserimento in coda
   for (int i=0; i<5; i++)
   {
     num = intToString(i);
     ins_coda(il, "titolo"+num, "autore"+num, 
                   i, "url"+num);
   }    
   cout << "\n-----------------------------------\n";
   stampaLista(il);
   cout << "\n-----------------------------------\n";
   
   mp3 *cercato = cerca(il, "autore3");
   
   if (cercato!=NULL)
     cout << cercato -> autore << " - " << cercato -> titolo << endl;        
   else
     cout << "Non trovato ...\n";
     
 
   
    system("PAUSE");
    return EXIT_SUCCESS; 
}









